#!/bin/bash
# Program:
#   Deploy PXE PV VM to DRBL client
# Author: 
#   Jazz, Rock {jazz, rock}@nchc.org.tw
# Version:
#    1.0
# History:                                                                                          
#   2010/08/27  Rock    First release (1.0) 

# [Source]
source /opt/drbl-virt/conf/drbl-virt.conf
source $Work_Path/functions_drbl_virt
#source ./functions_drbl_PXE_PV-VM_create


# [Declation]
# = 1. Varibales declation =
#vm_dir="/home/domains"


# = 2. Functions declation =
Usage(){
echo "Usage: drbl_xen_cmd.sh options"
echo "Options:"
echo "-c|--client         client name"
echo "-x|--execute        execute command"
echo "Example:"
echo "drbl_xen_cmd.sh -c drbl101 -x 'shutdown'"
}


# [Main]
check_root
# = 1. Parse parameters = 
if [ $# -eq 0 ]; then
Usage && exit
fi

while [ $# -gt 0 ]; do
    case "$1" in
        -c|--client)
            shift 
            if [ -z "$(echo $1 |grep ^-.)" ]; then
                if [ -n "$(echo $1)" ]; then
                    client_name=$1
                else
                    echo "-h host_value is null"
                    Usage && exit 2
                fi
            shift 
            fi 
            ;; 
        -x|--command)
            shift 
            if [ -z "$(echo $1 |grep ^-.)" ]; then
                if [ -n "$(echo $1)" ]; then
                command="$1"
                else
                    echo "-x command is null"
                    Usage && exit 2
                fi  
            shift 
            fi  
            ;;
        -*)
            echo "$0 $1 invalid option" >&2
            echo ""
            Usage >&2
            exit 2
            ;;
        *)  Usage >&2
            exit 2
            ;;
    esac
done


# = 2. Check null value =
[ -z $client_name ] && echo "[Error] no host" && Usage && exit 2
[ -z "$command" ] && echo "[Error] no command" && Usage && exit 2


# = 3. Check client exist
grep $client_name $Work_Home/etc/IP_HOST_TABLE >> /dev/null
if [ $? -ne 0 ]; then
    echo "[Error] This host is not DRBL client"
    exit 2
fi

echo "[$client_name]"

# = 4. ssh host to deploy VM  =
# local varibales
host_IP=$(cat $Work_Home/etc/IP_HOST_TABLE | grep $client_name | awk '{print $1}')

# start ssh
ssh -o StrictHostKeyChecking=no $host_IP "$command"

